----------------------------------------
-- All custom flags used in Sacrifice --
----------------------------------------


--------------------
-- Transit Turtle --
--------------------
TRANSTURTLE_GO = 1
TRANSTURTLE_ACTIVE = 2
TRANSTURTLE_EXIT = 3
TRANSTURTLE_FIRST = 4

TRANSTURTLE_HOME = 5
TRANSTURTLE_FOREST01 = 6
TRANSTURTLE_VEIL01 = 7
TRANSTURTLE_OPENWATER01 = 8
TRANSTURTLE_ABYSS01 = 9

TRANSTURTLE_GO_HOME = 15
TRANSTURTLE_GO_FOREST01 = 16
TRANSTURTLE_GO_VEIL01 = 17
TRANSTURTLE_GO_OPENWATER01 = 18
TRANSTURTLE_GO_ABYSS01 = 19

TRANSTURTLE_ACTIVATE = 23
TRANSTURTLE_DEACTIVATE= 24


-----------
-- Forms --
-----------
LEARNED_SHIELD = 30
LEARNED_BIND = 31
LEARNED_ENERGY = 32
LEARNED_BEAST = 33
LEARNED_SUN = 34
LEARNED_FISH = 35
LEARNED_NATURE = 36


--------------------
-- Story Elements --
--------------------
SUPPORT_VEDHA = 39
NEW_GAME = 40
HINT_DIALOGUE_OPTIONS = 41
QUEST_DRASK1 = 42
KROTITE_ENCOUNTER = 43
FOUND_SKULL = 44
QUEST_DRASK2 = 45
IMPRISONED = 46
BIGBLASTER = 47
LOAD_VISION = 48
MITHALAS_VISION = 49
MITHALAS_CORRUPTED = 50
KILLED_ROTCORE = 51
QUEST_OLDFRED_SOUP = 53
MORAL_SAUGUIN = 54
DEATH_OF_DRASK = 55
QUEST_WALKER1 = 56
DEFEND_CRYSTALS = 57
MITHALA_STANCE = 58
FINAL_CONFRONTATION = 59


---------------
-- NARRATION --
---------------
NARRATION_ENERGYTEMPLE = 60
NARRATION_FOREST01 = 61
NARRATION_CATHEDRALPRIEST = 62


--------------
-- CutScene --
--------------
CS_PIPESUCK = 70
CS_PIPETRAVEL = 71
CS_PIPEEXIT = 72
CS_DRASKBATTLE = 73
CS_DRUNIADS = 74
CS_GHOSTS_IN_MITHALAS = 75
CS_KINGSBETRAYAL = 76
NIGHTMARE_HOLE = 77
NIGHTMARE_WOAH = 78
CS_MIATAKESMITHALA = 79
VISION_2 = 80


-------------------
-- Permant Moves --
-------------------
--ROCK: change position after move through node
ROCK_FOREST01 = 85

--Energy Doors (stay open)
ED_OLDFRED_01 = 86
ED_OLDFRED_02 = 87
ED_OLDFRED_03 = 88
ED_OLDFRED_04 = 89
ED_ENTER_FOREST02 = 90
ED_PRIEST_BATTLE = 91
ED_OPENWATERS_HEALTH_1 = 92
ED_OPENWATERS_HEALTH_2 = 93
ED_ENERGYTEMPLE02_STATUE = 94
ED_ENTER_CATHEDRALPRIEST = 95
ED_ENERGYTEMPLE01_BOSS = 96
ED_ENERGYTEMPLE01_MINIBOSS = 97


--------------------
-- Crystal Vendor --
--------------------
VENDOR_FIRST = 100
VENDOR_ACTIVE = 101
VENDOR_EXIT = 102

VENDOR_BOUGHT_NATURE = 103
VENDOR_BOUGHT_FISH = 104
VENDOR_BOUGHT_CRYSTALS_1 = 105
VENDOR_BOUGHT_SEAHORSE = 106
VENDOR_BOUGHT_HEALTH = 107
VENDOR_BOUGHT_CRYSTALS_2 = 108

CREATE_CRYSTALS_1 = 109
CREATE_SEAHORSE = 110
CREATE_HEALTH = 111
CREATE_CRYSTALS_2 = 112

--Vendor Crystals
TOTAL_CRYSTALS = 113
CURRENCY = 114

--view vision
VIEW_VISION_1 = 115
VIEW_VISION_2 = 116

FIRST_LARGE_CRYSTAL = 119

-----------------
-- Food Vendor --
-----------------
CURRENCY_SMALL_CRYSTALS = 121
TOTAL_SMALL_CRYSTALS = 122
FOOD_CHANGE_MODE = 123

--Mithalas Young Fred
VENDORM_FOOD_FIRST = 130
VENDORM_FOOD_ACTIVE = 131
VENDORM_FOOD_EXIT = 132
VENDORM_FOOD_TAB = 133


-------------------------
-- Standardized Vendor --
-------------------------
MENU_ACTIVE = 135
MENU_TAB = 136
MENU_CHANGE_MODE = 137
MENU_EXIT = 138


------------------
-- Arena Master --
------------------
ARENA_FIRST = 140
ARENA_COMPLETE = 141
ARENA_NAME = 142
ARENA_PLACE_TIMERS = 143
ARENA_DELETE_TIMERS = 144

TIMER_COMBAT01 = 145
TIMER_COMBAT02 = 146
TIMER_COMBAT03 = 147
TIMER_COMBAT04 = 148
TIMER_COMBAT05 = 149
TIMER_COMBAT06 = 150

TIMER_NAVIGATION01 = 150
TIMER_NAVIGATION02 = 151
TIMER_NAVIGATION03 = 152
TIMER_NAVIGATION04 = 153
TIMER_NAVIGATION05 = 154
TIMER_NAVIGATION06 = 155

TIMER_BOSS_BOILERROOM = 161
TIMER_BOSS_SUNWORMTEST = 162
TIMER_BOSS_CATHEDRAL04 = 163
TIMER_BOSS_TREE02 = 164
TIMER_BOSS_ENERGYTEMPLE05 = 165
TIMER_BOSS_ = 166


-----------------------------
-- New Map/Area CenterText --
-----------------------------
ENTER_GUESTQUARTERS = 180
ENTER_LIBRARY = 181
ENTER_THRONEROOM = 182
ENTER_MITHALAS = 183
ENTER_THEKELPFOREST = 184
ENTER_THEENERGYTEMPLE = 185
ENTER_THEVEIL = 186
ENTER_OPENWATER = 187
ENTER_THEABYSS = 188
ENTER_CRYSTALCAVE = 189


--------------------
-- Dialogue Trees --
--------------------
--Dialogue Tree Flags for Navigation...Even I'm Confused
DT_SETUP = 200
DT_EXIT = 201
DT_REPEAT = 202
DT_CREATE = 203
DT_ACTIVE = 204

--Clickable buttons
DT_OPTION1 = 205
DT_OPTION2 = 206
DT_OPTION3 = 207
DT_NEXT = 208

--Button clicked
CLICKED_OPTION1 = 209
CLICKED_OPTION2 = 210
CLICKED_OPTION3 = 211
CLICKED_NEXT = 212

--Flagged when in conversation with
DT_ACTIVE_VISION1 = 214
DT_ACTIVE_FINALCONFRONTATION = 215
DT_ACTIVE_DEATHWISH = 216
DT_ACTIVE_BOOKCASE = 217
DT_ACTIVE_SCOUT = 218
DT_ACTIVE_GUARD = 219
DT_ACTIVE_ARCHIVIST = 220
DT_ACTIVE_DRASK = 221
DT_ACTIVE_MITHALAN01 = 222
DT_ACTIVE_MITHALAN02 = 223
DT_ACTIVE_MITHALAN03 = 224
DT_ACTIVE_RAJAH = 225
DT_ACTIVE_MIA = 226
DT_ACTIVE_NAIJA = 227
DT_ACTIVE_WALKER = 228
DT_ACTIVE_KROTITE = 229
DT_ACTIVE_SQUIDDY = 230
DT_ACTIVE_GARY = 231
DT_ACTIVE_YOUNGFRED = 232
DT_ACTIVE_OLDFRED = 233
DT_ACTIVE_SAUGUIN = 234
DT_ACTIVE_EXTRA01 = 235
DT_ACTIVE_EXTRA02 = 236
DT_ACTIVE_EXTRA03 = 237
DT_ACTIVE_EXTRA04 = 238
DT_ACTIVE_KALEB = 239
DT_ACTIVE_PRIESTESS01 = 240
DT_ACTIVE_MITHALA = 241
DT_ACTIVE_LUMEREAN01 = 242
DT_ACTIVE_LUMEREAN02 = 243

--Main (start at 'main' dialogue panel once reached)
DT_MAIN_NAIJA_V3 = 244
DT_MAIN_RAJAH_V2 = 245
DT_MAIN_MIA_V1 = 246
DT_MAIN_DRASK_V2 = 247
DT_MAIN_OLDFRED_V1 = 248
DT_MAIN_SCOUT = 249

--Version (conversation number)
DT_VERSION_GUARD = 250
DT_VERSION_ARCHIVIST = 251
DT_VERSION_DRASK = 252
DT_VERSION_WALKER = 253
DT_VERSION_RAJAH = 254
DT_VERSION_MIA = 255
DT_VERSION_OLDFRED = 256
DT_VERSION_YOUNGFRED = 257
DT_VERSION_NAIJA = 258

--Repeater (one liner summaries(generally) after main conversation done) equal to DT_VERSION once flagged
DT_REPEAT_GUARD = 265
DT_REPEAT_ARCHIVIST = 266
DT_REPEAT_DRASK = 267
DT_REPEAT_WALKER = 268
DT_REPEAT_RAJAH = 269
DT_REPEAT_GARY = 270
DT_REPEAT_MITHALAN03 = 271
DT_REPEAT_OLDFRED = 272
DT_REPEAT_NAIJA = 273
DT_REPEAT_LUMEREAN01 = 274

--Chat Bubble (something new to say?)
DT_NEW_SCOUT = 278
DT_NEW_MITHALA = 279
DT_NEW_GUARD = 280
DT_NEW_ARCHIVIST = 281
DT_NEW_DRASK = 282
DT_NEW_WALKER = 283
DT_NEW_RAJAH = 284
DT_NEW_GARY = 285
DT_NEW_MITHALAN01 = 286
DT_NEW_MITHALAN02 = 287
DT_NEW_MITHALAN03 = 288
DT_NEW_EXTRA01 = 289
DT_NEW_EXTRA02 = 290
DT_NEW_EXTRA03 = 291
DT_NEW_EXTRA04 = 292
DT_NEW_LUMEREAN01 = 293
DT_NEW_LUMEREAN02 = 294
DT_NEW_OLDFRED = 295
DT_NEW_YOUNGFRED = 296
DT_NEW_NAIJA = 297
DT_NEW_MIA = 298
DT_NEW_KALEB = 299
DT_NEW_PRIESTESS01 = 300


------------
-- DLC 01 --
------------
DT_VERSION_NAIJA_DLC01 = 300
DT_VERSION_OLDFRED_DLC01 = 301
DT_REPEAT_NAIJA_DLC01 = 302
DT_NEW_NAIJA_DLC01 = 303
DT_NEW_OLDFRED_DLC01 = 304
DT_MAIN_OLDFRED_DLC01 = 305
FEDOR_FIRST_RIDE = 306
FEDOR_RIDING = 307
HINT_WORLDMAP = 308
HINT_VORTEX = 309
FEDOR_HANGOUT = 310

------------------
-- NEW DT STUFF --
------------------
DT_VERSION_MITHALAN01 = 401
DT_VERSION_MITHALAN02 = 402
DT_VERSION_MITHALAN03 = 403
DT_VERSION_MITHALAN04 = 404
DT_VERSION_BOOKCASE = 405
DT_VERSION_DEATHWISH = 406
DT_NEW_DEATHWISH = 407
DT_VERSION_EXTRA01 = 408
DT_VERSION_EXTRA02 = 409
DT_VERSION_EXTRA03 = 410
DT_VERSION_EXTRA04 = 411
DT_VERSION_PRIESTESS01 = 412
DT_VERSION_DEATHWISH = 413
DT_VERSION_GARY = 414
DT_VERSION_KALEB = 415
DT_VERSION_KROTITE = 416
DT_NEW_KROTITE = 417
DT_VERSION_LUMEREAN01 = 418
DT_VERSION_LUMEREAN02 = 419
DT_MAIN_MIA = 420
DT_VERSION_MITHALA = 421
DT_MAIN_NAIJA = 422
DT_MAIN_RAJAH = 423
DT_VERSION_SAUGUIN = 424
DT_VERSION_SCOUT = 425
DT_VERSION_VISION01 = 426
DT_MAIN_DRASK = 427
DT_VERSION_SQUIDDY = 428
RESET_GEM_NAIJA = 429

-----------------------
-- DON't USE 500-600 --
-----------------------